import React, { useState, useEffect } from "react";
import { useNavigate } from "react-router-dom";
import { getAuthToken } from "../api.jsx";
import {
  getStatuses,
  createStatus,
  updateStatus,
  deleteStatus,
} from "../api.jsx";

const Statuses = () => {
  const [statuses, setStatuses] = useState([]);
  const [newStatus, setNewStatus] = useState({
    name: "",
  });
  const [editingStatusId, setEditingStatusId] = useState(null);
  const [error, setError] = useState(null);
  const navigate = useNavigate();

  useEffect(() => {
    fetchStatuses();
  }, []);

  const fetchStatuses = async () => {
    try {
      const data = await getStatuses();
      setStatuses(data);
    } catch (error) {
      if (error.response && error.response.status === 401) {
        navigate("/login");
      }
      console.error("Ошибка при загрузке статусов:", error);
    }
  };

  const handleInputChange = (e) => {
    const { name, value } = e.target;
    setNewStatus({ ...newStatus, [name]: value });
  };

  const handleSubmit = async (e) => {
    e.preventDefault();

    if (!newStatus.name) {
      setError("Пожалуйста, заполните все поля.");
      return;
    }

    try {
      if (editingStatusId) {
        await updateStatus(editingStatusId, newStatus);
      } else {
        await createStatus(newStatus);
      }
      fetchStatuses();
      resetForm();
    } catch (error) {
      console.error("Ошибка при добавлении или обновлении статуса:", error);
    }
  };

  const handleEdit = (status) => {
    setNewStatus({
      name: status.name,
    });
    setEditingStatusId(status.id);
  };

  const handleDelete = async (statusId) => {
    try {
      await deleteStatus(statusId);
      fetchStatuses();
    } catch (error) {
      console.error("Ошибка при удалении статуса:", error);
    }
  };

  const resetForm = () => {
    setNewStatus({
      name: "",
    });
    setEditingStatusId(null);
  };

  if (getAuthToken() === null) {
    navigate("/login");
  }

  return (
    <div className="container mt-4">
      <h3>Статусы</h3>
      <form onSubmit={handleSubmit}>
        <div className="form-group">
          <label htmlFor="statusName">Название статуса</label>
          <input
            type="text"
            className="form-control"
            id="statusName"
            name="name"
            placeholder="Введите название статуса"
            value={newStatus.name}
            onChange={handleInputChange}
          />
        </div>

        <div className="btn-group">
          <button type="submit" className="btn btn-primary">
            {editingStatusId ? "Обновить" : "Создать"}
          </button>
          <button
            type="button"
            className="btn btn-secondary"
            onClick={resetForm}
          >
            Отменить
          </button>
        </div>
        {error && (
          <div className="alert alert-danger mt-3" role="alert">
            {error}
          </div>
        )}
      </form>
      <h3 className="mt-5">Список статусов</h3>
      <table className="table table-bordered">
        <thead>
          <tr>
            <th>Название</th>
            <th>Действия</th>
          </tr>
        </thead>
        <tbody>
          {statuses.map((status) => (
            <tr key={status.id}>
              <td>{status.name}</td>
              <td>
                <div className="btn-group">
                  <button
                    className="btn btn-warning"
                    onClick={() => handleEdit(status)}
                  >
                    Изменить
                  </button>
                  <button
                    className="btn btn-danger"
                    onClick={() => handleDelete(status.id)}
                  >
                    Удалить
                  </button>
                </div>
              </td>
            </tr>
          ))}
        </tbody>
      </table>
    </div>
  );
};

export default Statuses;
